# 微信小程序支付接入规范文档4.2.1
[上海偶可贝网络科技有限公司](https://www.allpayx.com)

* 版本信息：中文 V4.2.1
* 更新时间：2018 年6 月

#### 1.概述

AllPay为基于微信小程序开发的接口，以帮助客户实现快速、安全、集中式的接入支付渠道。 

#### 2.通用API说明 

商户服务器和 AllPay 网关对接的通用接口，每个渠道都具有的功能，包括：消费，查询，退款，退款查询接口。

##### 2.1. 验签说明 

```
1.对于发送到 AllPay 系统的 POST 请求报文，其中所有传入参数(除 signature 参数外)按照字段名的 ASCII 码从小到大排序后(字典序)，使用 URL 键值对的格式(即 key1=value1&key2=value2...)拼接成字符串 String1。

2.在 String1 最后直接拼接（不需要用“&”连接）双方约定的签名密钥 Key(接入 AllPay 时分配)，得到 stringSignTemp 字符串，并对 stringSignTemp 进行 md5 运算，得到 signature 的值。

3.示例签名串 acqID=99020344&backURL=https://www.allpayx.com&charSet=UTF-8&frontURL=https://www.baidu.com&goodsInfo=apple&merID=000000000000015&merReserve=iPhone&mode=applet&openid=1425364758&orderAmount=0.01&orderCurrency=USD&orderNum=20190104034651&paymentSchema=WX&signType=MD5&transTime=20190104034651&transType=PURC&version=VER0000000022f2c77e3718c47cfb47a89a6fbc9d361
```

##### 2.2. 通用API接入地址 

| 接口名称     | 测试地址                                  | 生产地址                              |
| ------------ | ----------------------------------------- | ------------------------------------- |
| 消费接口     | <https://testapi.allpayx.com/gw/wap/pay> | <https://api.allpayx.com/gw/wap/pay>  |
| 交易查询接口 | <https://testapi.allpayx.com/pay>         | <https://api.allpayx.com/pay>         |
| 退款接口     | <https://testapi.allpayx.com/refund>      | <https://api.allpayx.com/refund>      |
| 退款查询接口 | <https://testapi.allpayx.com/refundquery> | <https://api.allpayx.com/refundquery> |

#### 3. API接口

##### 3.1. 消费接口

1.请求报文格式

 序号 |名称  |长度|类型|参数名称|备注 
 -----|-----|----|----|------|------
 1|版本号|12|文本|version |统一填写为“VER000000002” 
 2|字符集编码 |6|文本|charSet  |统一填写为“UTF-8” 
 3|交易类型  |4|文本|transType |消费交易填写“PURC” 
 4|订单号   |60|文本|orderNum  |商户自行定义，需保证同一商户号下订单号不能重复 
 5|交易模式|10|文本|mode |"applet"
 6|openeid|60|文本|openid   |微信openid 
 7|订单金额 |12|文本|orderAmount   |如 100 元，表示为 100 或 100.00 
 8|订单币种   |3|文本|orderCurrency |人民币填写“CNY”,美元填写"USD" 
 9 |前端 URL 地址 |400|文本|frontURL  |支付结果前端通知到该地址 
 10|后端 URL 地址 |400|文本|backURL   |支付结果异步通知到该地址 
 11|商户预留字段  |1024 |文本|merReserve    |商户预留内容，可传任意内容，如购买商品信息、员号等，但不要传特殊符号，如逗号。 
 12|商户代码   |15 |文本|merID     |商户 ID，由AllPay 分配 
 13|收单行 ID    |11  |文本|acqID      |收单行 ID "99020344" 
 14|支付渠道代码    |10  |文本|paymentSchema| "WX"
 15|商品信息    |60  |文本|goodsInfo       | 商品信息
 16|交易时间    |14  |文本|transTime       |交易时间,格式:"yyyyMMddHHmmss" 
 17|签名类型     |3  |文本|signType        |MD5 
 18 |签名      |32  |文本|signature         |采用 MD5 签名 

2.返回数据格式

 ```
 {'timeStamp': '',
  'nonceStr': '',
  'package': '',
  'signType': 'MD5',
  'paySign': ''}
 ```

将上述返回数据放入微信小程序支付接口,即可调起微信小程序支付,具体方法,参考[微信小程序API](https://developers.weixin.qq.com/miniprogram/dev/api/api-pay.html#wxrequestpaymentobject)

3.异步通知报文

序号 |名称  |长度|类型|参数名称|备注 
 -----|-----|----|----|------|------
 1|版本号|12|文本|version |统一填写为“VER000000002” 
 2|字符集编码 |6|文本|charSet  |统一填写为“UTF-8” 
 3|交易类型  |4|文本|transType |返回“PURC” 
 4|订单号   |60|文本|orderNum  |商户自行定义，需保证同一商户号下订单号不能重复 
 5|订单金额 |12|文本|orderAmount   |如 100 元，表示为 100 或 100.00 
 6|订单币种   |3|文本|orderCurrency |人民币填写“CNY”,美元填写"USD" 
 7|清算金额  |12 |文本|settAmount   |如 100 元，表示为 100 或 100.00  
 8|清算币种  |3|文本|settCurrency    |符合 ISO 标准，填写数字类型 
 9|清算汇率   |7|文本|rate     |实际汇率，7 位有效数字  
 10|商户预留字段  |1024 |文本|merReserve    |商户预留内容，可传任意内容，如购买商品信息、员号等，但不要传特殊符号，如逗号。 
 11|GW 交易 ID  |32|文本|transID    |GW 系统生成的交易 ID，每笔交易保持唯一
 12|商户代码   |15 |文本|merID     |商户 ID，由AllPay 分配 
 13|收单行 ID    |11  |文本|acqID      |收单行 ID "99020344" 
 14|支付渠道代码    |10  |文本|paymentSchema|渠道代码："WX"
 15|交易应答码   |2  |文本|RespCode       |应答码 00-成功  
 16|应答文字信息    |20  |文本|RespMsg        |应答消息，全部为英文字符 
 17|交易时间    |14  |文本|transTime       |交易时间,格式:"yyyyMMddHHmmss" 
 18|GW 处理时间 |14  |文本|GWTime |YYYYMMDDHHMMSS，为 GW 时间，目前为本地交易时间
 19|签名类型     |3  |文本|signType        |MD5 
 20|签名      |32  |文本|signature         |采用 MD5 签名 

##### 3.2. 交易查询接口 

1.接口说明

 该接口为接入商家提供交易查询的功能。

2.请求报文格式 

 序号 |名称  |长度|类型|参数名称|备注 
 -----|-----|----|----|------|------
 1|版本号|12|文本|version |统一填写为“VER000000002” 
 2|字符集编码 |6|文本|charSet  |统一填写为“UTF-8” 
 3|交易类型  |4|文本|transType |查询填写“INQY”  
 4|订单号   |60|文本|orderNum  |商户自行定义，需保证同一商户号下订单号不能重复 
 5|商户预留字段  |1024 |文本|merReserve    |商户保留 
 6|商户代码   |15 |文本|merID     |商户 ID，由AllPay 分配 
 7|收单行 ID    |11  |文本|acqID      |收单行 ID "99020344" 
 8|支付渠道代码    |10  |文本|paymentSchema|渠道代码："WX"
 9|交易时间    |14  |文本|transTime       |交易时间,格式:"yyyyMMddHHmmss" 
 10|签名类型     |3  |文本|signType        |MD5 
 11|签名      |32  |文本|signature         |采用 MD5 签名 

3.响应报文格式

  序号 |名称  |长度|类型|参数名称|备注 
 -----|-----|----|----|------|------
 1|版本号|12|文本|version |统一填写为“VER000000002” 
 2|字符集编码 |6|文本|charSet  |统一填写为“UTF-8” 
 3|交易类型  |4|文本|transType |返回“PURC”
 4|订单号   |60|文本|orderNum  |商户自行定义，需保证同一商户号下订单号不能重复 
 5|GW 交易 ID  |32|文本|transID    |GW 系统生成的交易 ID，每笔交易保持唯一  
 6|商户代码   |15 |文本|merID     |商户 ID，由AllPay 分配 
 7|收单行 ID    |11  |文本|acqID      |收单行 ID "99020344" 
 8|交易应答码   |2  |文本|RespCode       |应答码 00-成功  
 9|应答文字信息    |20  |文本|RespMsg        |应答消息，全部为英文字符 
 10|交易时间    |14  |文本|transTime       |交易时间,格式:"yyyyMMddHHmmss" 
 11|GW 处理时间 |14  |文本|GWTime |YYYYMMDDHHMMSS，为 GW 时间，目前为本地交易时间 
 12|签名类型     |3  |文本|signType        |MD5 
 13|签名      |32  |文本|signature         |采用 MD5 签名 

##### 3.3. 退款接口

1.接口说明 

该接口为接入商家提供交易退款的功能。 

2.请求报文格式 

序号 |名称  |长度|类型|参数名称|备注 
 -----|-----|----|----|------|------
 1|版本号|12|文本|version |统一填写为“VER000000002” 
 2|字符集编码 |6|文本|charSet  |统一填写为“UTF-8” 
 3|交易类型  |4|文本|transType |退款填写“REFD” 
 4|订单号   |60|文本|orderNum  |商户自行定义，需保证同一商户号下订单号不能重复 
 5|退款金额  |12|文本|returnAmount    |如 100 元，表示为 100 或 100.00 
 6|订单币种   |3|文本|orderCurrency |人民币填写“CNY”,美元填写"USD" 
 7|商户预留字段  |1024 |文本|merReserve    |商户预留内容，可传任意内容，如购买商品信息、员号等，但不要传特殊符号，如逗号。 
 8|商户代码   |15 |文本|merID     |商户 ID，由AllPay 分配 
 9|收单行 ID    |11  |文本|acqID      |收单行 ID "99020344" 
 10|支付渠道代码    |10  |文本|paymentSchema|渠道代码："WX"
 11|交易时间    |14  |文本|transTime       |交易时间,格式:"yyyyMMddHHmmss" 
 12|签名类型     |3  |文本|signType        |MD5 
 13|签名      |32  |文本|signature         |采用 MD5 签名 

3.响应报文格式

  序号 |名称  |长度|类型|参数名称|备注 
 -----|-----|----|----|------|------
 1|版本号|12|文本|version |统一填写为“VER000000002” 
 2|字符集编码 |6|文本|charSet  |统一填写为“UTF-8” 
 3|交易类型  |4|文本|transType |返回“REFD” 
 4|订单号   |60|文本|orderNum  |商户自行定义，需保证同一商户号下订单号不能重复 
 5|GW 交易 ID  |32|文本|transID    |GW 系统生成的交易 ID，每笔交易保持唯一  
 6|商户代码   |15 |文本|merID     |商户 ID，由AllPay 分配 
 7|收单行 ID    |11  |文本|acqID      |收单行 ID "99020344" 
 8|交易应答码   |2  |文本|RespCode       |应答码 00-成功  
 9|应答文字信息    |20  |文本|RespMsg        |应答消息，全部为英文字符 
 10|交易时间    |14  |文本|transTime       |交易时间，格式:"yyyyMMddHHmmss" 
 11|GW 处理时间 |14  |文本|GWTime |YYYYMMDDHHMMSS，为 GW 时间，目前为本地交易时间 
 12|签名类型     |3  |文本|signType        |MD5 
 13|签名      |32  |文本|signature         |采用 MD5 签名 

##### 3.4. 退款查询接口

1.接口说明

 该接口为接入商家提供退款查询的功能。

2.请求报文格式 

| 参数          | 类型         | 属性 | 描述                                                         |
| ------------- | ------------ | ---- | ------------------------------------------------------------ |
| version       | String(12)   | M    | 统一填写为“VER000000002”                                     |
| charSet       | String(6)    | M    | 统一填写为“UTF-8”                                            |
| transType     | String(4)    | M    | 退款查询填写“RFQY”                                               |
| refundNum     | String(60)   | M    | 退款订单号                                                   |
| merReserve    | String(1024) | M    | 商户预留内容，可传任意内容，如购买商品信息、员号等，但不要传特殊符号，如逗号。 |
| merID         | String(15)   | M    | 商户 ID，由 AllPay 分配                                       |
| acqID         | String(11)   | M    | 收单行 ID "99020344"                                         |
| paymentSchema | String(10)   | M    | 渠道代码："WX"                                               |
| transTime     | String(14)   | M    | 交易时间，格式:"yyyyMMddHHmmss"                               |
| signType      | String(3)    | M    | MD5                                                          |
| signature     | String(32)   | M    | 采用 MD5 签名                                                |

3.响应报文格式

| 参数          | 类型       | 属性 | 描述                                                         |
| ------------- | ---------- | ---- | ------------------------------------------------------------ |
| version       | String(12) | M    | 统一填写为“VER000000002”                                     |
| charSet       | String(6)  | M    | 统一填写为“UTF-8”                                            |
| transType     | String(4)  | M    | 返回“REFD”                                               |
| refundNum     | String(60) | M    | 退款订单号                                                   |
| transID       | String(32) | M    | GW 系统生成的交易 ID，每笔交易保持唯一                       |
| merID         | String(15) | M    | 商户 ID，由AllPay 分配                                       |
| acqID         | String(11) | M    | 收单行 ID "99020344"                                         |
| paymentSchema | String(10) | M    | 渠道代码："WX"                                               |
| RespCode      | String(2)  | M    | 应答码 00-成功                                               |
| RespMsg       | String(20) | M    | 应答消息，全部为英文字符                                     |
| transTime     | String(14) | M    | 交易时间,格式:"yyyyMMddHHmmss"                               |
| GWTime        | String(14) | M    | YYYYMMDDHHMMSS，为 GW 时间，目前为本地交易时间               |
| signType      | String(3)  | M    | MD5                                                          |
| signature     | String(32) | M    | signature                                                    |

#### 4. 错误码

若商户请求AllPay网关时，请求的参数错误或参数缺失时，AllPay网关会将错误信息以JSON格式返回给客户端，供商户解析调用，以下是相关错误信息返回参数的说明

| 参数应答码code | 对应应答信息msg                            |
| -------------- | ------------------------------------------ |
| U1             | Clientid not found                         |
| U2             | Signature error                            |
| V1             | Parameter missing                          |
| E1             | Exceed the limit                           |
| R1             | Orderno repeat                             |
| C1             | Order currency is not set                  |
| P1             | paychannel error                           |
| I1             | Illegal request address                    |
| T1             | Parameter missing（version或tranType）     |
| T2             | Txntype error                              |
| T3             | transaction is not exist or fail           |
| T4             | The maximum amount exceeds the upper limit |
| 99             | System error                               |

#### 5.技术支持

如果您在调试时遇到问题，请与我们联系：support@allpayx.com。